package name.panitz.kotlin.date;

import org.junit.Assert.*

import org.junit.Before
import org.junit.Test
import java.lang.reflect.Modifier


class DateTest {
  init {
    ClassLoader.getSystemClassLoader().setDefaultAssertionStatus(true);
  }
  internal var d0: Date = Date(1,1,1970)
  internal var d1: Date = Date(1,1,1970)
  internal var d2: Date = Date(1,1,1970)
  internal var d3: Date = Date(1,1,1970)
  internal var d4: Date = Date(1,1,1970)
  internal var d5: Date = Date(1,1,1970)
  internal var d6: Date = Date(1,1,1970)
  internal var d7: Date = Date(1,1,1970)
  internal var d8: Date = Date(1,1,1970)
  internal var d9: Date = Date(1,1,1970)
  internal var d10: Date= Date(1,1,1970)

  @Before
  @Throws(Exception::class)
  fun setUp() {
    d0 = Date(10, 6, 1979)
    d1 = Date(10, 5, 1980)
    d2 = Date(29, 4, 1981)
    d3 = Date(11, 11, 1982)
    d4 = Date(24, 12, 1983)
    d5 = Date(29, 2, 1984)
    d6 = Date(5, 2, 1985)
    d7 = Date(28, 2, 2000)
    d8 = Date(17, 3, 2001)
    d9 = Date(31, 12, 2002)
    d10 = Date(1, 10, 2004)

  }

  private fun testNextDay(d: Date, e: Date) {
    val n = d.nextDay()
    assertTrue("falscher Nächster Tag für: $d. Erwartet wurde: $e aber war: $n", e.day == n.day && e.month == n.month && e.year == n.year)

  }

  @Test
  fun testNext0() {
    testNextDay(d0, Date(11, 6, 1979))
  }

  @Test
  fun testNext1() {
    testNextDay(d1, Date(11, 5, 1980))
  }

  @Test
  fun testNext2() {
    testNextDay(d2, Date(30, 4, 1981))
  }

  @Test
  fun testNext3() {
    testNextDay(d3, Date(12, 11, 1982))
  }

  @Test
  fun testNext4() {
    testNextDay(d4, Date(25, 12, 1983))
  }

  @Test
  fun testNext5() {
    testNextDay(d5, Date(1, 3, 1984))
  }

  @Test
  fun testNext6() {
    testNextDay(d6, Date(6, 2, 1985))
  }

  @Test
  fun testNext7() {
    testNextDay(d7, Date(29, 2, 2000))
  }

  @Test
  fun testNext8() {
    testNextDay(d8, Date(18, 3, 2001))
  }

  @Test
  fun testNext9() {
    testNextDay(d9, Date(1, 1, 2003))
  }

  @Test
  fun testNext10() {
    testNextDay(d10, Date(2, 10, 2004))
  }

  private fun testMothersDay(d: Date, e: Date) {
    val n = d.mothersDay()
    assertTrue("falscher Muttertag für: $d. Erwartet wurde: $e aber war: $n", e.day == n.day && e.month == n.month && e.year == n.year)

  }

  @Test
  fun testMothesNext0() {
    testMothersDay(d0, Date(13, 5, 1979))
  }

  @Test
  fun testMothesNext1() {
    testMothersDay(d1, Date(11, 5, 1980))
  }

  @Test
  fun testMothesNext2() {
    testMothersDay(d2, Date(10, 5, 1981))
  }

  @Test
  fun testMothesNext3() {
    testMothersDay(d3, Date(9, 5, 1982))
  }

  @Test
  fun testMothesNext4() {
    testMothersDay(d4, Date(8, 5, 1983))
  }

  @Test
  fun testMothesNext5() {
    testMothersDay(d5, Date(13, 5, 1984))
  }

  @Test
  fun testMothesNext6() {
    testMothersDay(d6, Date(12, 5, 1985))
  }

  @Test
  fun testMothesNext7() {
    testMothersDay(d7, Date(14, 5, 2000))
  }

  @Test
  fun testMothesNext8() {
    testMothersDay(d8, Date(13, 5, 2001))
  }

  @Test
  fun testMothesNext9() {
    testMothersDay(d9, Date(12, 5, 2002))
  }

  @Test
  fun testMothesNext10() {
    testMothersDay(d10, Date(9, 5, 2004))
  }

  private fun testHTML(d: Date, e: String) {
    val m = d.monthAsHTML()
    assertEquals("Falscher HTML Kalender für: " + d, e, m.replace("\\s".toRegex(), ""))
  }

  @Test
  fun testHTML10() {
    testHTML(d10, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td></td><td>1</td><td>2</td><td>3</td></tr><tr><td>4</td><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td></tr><tr><td>11</td><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td></tr><tr><td>18</td><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td></tr><tr><td>25</td><td>26</td><td>27</td><td>28</td><td>29</td><td>30</td><td>31</td></tr></table>")
  }

  @Test
  fun testHTML0() {
    testHTML(d0, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td></td><td>1</td><td>2</td><td>3</td></tr><tr><td>4</td><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td></tr><tr><td>11</td><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td></tr><tr><td>18</td><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td></tr><tr><td>25</td><td>26</td><td>27</td><td>28</td><td>29</td><td>30</td></tr></table>")
  }

  @Test
  fun testHTML1() {
    testHTML(d1, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td>1</td><td>2</td><td>3</td><td>4</td></tr><tr><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td></tr><tr><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td></tr><tr><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td></tr><tr><td>26</td><td>27</td><td>28</td><td>29</td><td>30</td><td>31</td></tr></table>")
  }

  @Test
  fun testHTML2() {
    testHTML(d2, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td>1</td><td>2</td><td>3</td><td>4</td><td>5</td></tr><tr><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td><td>12</td></tr><tr><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td><td>19</td></tr><tr><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td><td>26</td></tr><tr><td>27</td><td>28</td><td>29</td><td>30</td></tr></table>")
  }

  @Test
  fun testHTML3() {
    testHTML(d3, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td>1</td><td>2</td><td>3</td><td>4</td><td>5</td><td>6</td><td>7</td></tr><tr><td>8</td><td>9</td><td>10</td><td>11</td><td>12</td><td>13</td><td>14</td></tr><tr><td>15</td><td>16</td><td>17</td><td>18</td><td>19</td><td>20</td><td>21</td></tr><tr><td>22</td><td>23</td><td>24</td><td>25</td><td>26</td><td>27</td><td>28</td></tr><tr><td>29</td><td>30</td></tr></table>")
  }

  @Test
  fun testHTML7() {
    testHTML(d7, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td>1</td><td>2</td><td>3</td><td>4</td><td>5</td><td>6</td></tr><tr><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td><td>12</td><td>13</td></tr><tr><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td><td>19</td><td>20</td></tr><tr><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td><td>26</td><td>27</td></tr><tr><td>28</td><td>29</td></tr></table>")
  }

  @Test
  fun testHTML8() {
    testHTML(d8, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td>1</td><td>2</td><td>3</td><td>4</td></tr><tr><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td></tr><tr><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td></tr><tr><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td></tr><tr><td>26</td><td>27</td><td>28</td><td>29</td><td>30</td><td>31</td></tr></table>")
  }

  @Test
  fun testHTML9() {
    testHTML(d9, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td></td><td></td><td></td><td>1</td></tr><tr><td>2</td><td>3</td><td>4</td><td>5</td><td>6</td><td>7</td><td>8</td></tr><tr><td>9</td><td>10</td><td>11</td><td>12</td><td>13</td><td>14</td><td>15</td></tr><tr><td>16</td><td>17</td><td>18</td><td>19</td><td>20</td><td>21</td><td>22</td></tr><tr><td>23</td><td>24</td><td>25</td><td>26</td><td>27</td><td>28</td><td>29</td></tr><tr><td>30</td><td>31</td></tr></table>")
  }

  @Test
  fun testHTML6() {
    testHTML(d6, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td></td><td></td><td>1</td><td>2</td><td>3</td></tr><tr><td>4</td><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td></tr><tr><td>11</td><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td></tr><tr><td>18</td><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td></tr><tr><td>25</td><td>26</td><td>27</td><td>28</td></tr></table>")
  }

  @Test
  fun testHTML5() {
    testHTML(d5, "<table><tr><th>Mo</th><th>Di</th><th>Mi</th><th>Do</th><th>Fr</th><th>Sb</th><th>So</th></tr><tr><td></td><td></td><td>1</td><td>2</td><td>3</td><td>4</td><td>5</td></tr><tr><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td><td>12</td></tr><tr><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td><td>19</td></tr><tr><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td><td>26</td></tr><tr><td>27</td><td>28</td><td>29</td></tr></table>")
  }


  fun eq(x: Date, y: Date): Boolean {
    return x.year == y.year && x.month == y.month && x.day == y.day
  }

  @Test
  fun testEaster1() {
    val result = Date(31, 12, 2018).easter()
    assertTrue("2018 ist Ostern am 1. April und nicht " + result, eq(Date(1, 4, 2018), result))
  }

  @Test
  fun testEaster2() {
    val result = Date(31, 12, 2019).easter()
    assertTrue("2019 ist Ostern am 21. April und nicht " + result, eq(Date(21, 4, 2019), result))
  }

  @Test
  fun test3Easter() {
    val result = Date(31, 12, 1901).easter()
    assertTrue("1901 war Ostern am 7. April und nicht " + result, eq(Date(7, 4, 1901), result))
  }

  @Test
  fun test4Eatser() {
    val result = Date(31, 12, 1980).easter()
    assertTrue("1980 war Ostern am 6. April und nicht " + result, eq(Date(6, 4, 1980), result))
  }

  @Test
  fun testEaster5() {
    val result = Date(31, 12, 2000).easter()
    assertTrue("2000 war Ostern am 23. April und nicht " + result, eq(Date(23, 4, 2000), result))
  }

  @Test
  fun testEaster6() {
    val result = Date(31, 12, 1997).easter()
    assertTrue("1980 war Ostern am 30. März und nicht " + result, eq(Date(30, 3, 1997), result))
  }

  @Test
  fun testDay1() {
    assertEquals("Der 10.5.1967 war ein Mittwoch.", 3, Date(10, 5, 1967).dayOfWeek())
  }

  @Test
  fun testDay2() {
    assertEquals("Der 27.10.2017 war ein Freitag.", 5, Date(27, 10, 2017).dayOfWeek())
  }

  @Test
  fun testDay3() {
    assertEquals("Der 14.7.1789 war ein Dienstag.", 2, Date(14, 7, 1789).dayOfWeek())
  }

  @Test
  fun testDay4() {
    assertEquals("Der 7.2.2016 war ein Sonntag.", 0, Date(7, 2, 2016).dayOfWeek())
  }

  @Test
  fun testDay5() {
    assertEquals("Der 8.5.1945 war ein Dienstag.", 2, Date(8, 5, 1945).dayOfWeek())
  }

  @Test
  fun testDay6() {
    assertEquals("Der 29.2.2000 war ein Dienstag.", 2, Date(29, 2, 2000).dayOfWeek())
  }

  @Test(expected = AssertionError::class)
  fun testAssert1() {
    val d1 = Date(81, 1, 1919)
  }

  @Test(expected = AssertionError::class)
  fun testAssert2() {
    val d1 = Date(-4, 1, 1919)
  }

  @Test(expected = AssertionError::class)
  fun testAssert3() {
    val d1 = Date(1, 14, 1919)
  }

  @Test(expected = AssertionError::class)
  fun testAssert4() {
    val d1 = Date(1, 0, 1919)
  }

  @Test
  fun testAssert5() {
    val d1 = Date(1, 1, 1919)
    assertEquals(d1,d1);
  }

  @Test
  fun test1() {
    val d = Date(1, 2, 1999)
    assertEquals("Tag nach Konstruktion nicht korrekt gesetzt", 1, d.day)
    assertEquals("Monat nach Konstruktion nicht korrekt gesetzt", 2, d.month)
    assertEquals("Jahr nach Konstruktion nicht korrekt gesetzt", 1999, d.year)
  }

  @Test
  fun test2() {
    val d = Date(10, 12, 1999)
    assertEquals("toString nicht nach der Spezifikation", "Fr 10.12.1999", d.toString())
  }

}